#ifndef lint
static char *SccsId = "@(#)hpg.misc.c 1.0 (TU-Delft) 22/02/95";
#endif

#include <stdio.h>
#include <math.h>
#include <string.h>
#include <sys/pstat.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Xaw/Label.h>
#include "bitmaps/f_0"
#include "bitmaps/f_1"
#include "bitmaps/f_2"
#include "bitmaps/f_3"
#include "bitmaps/f_4"
#include "bitmaps/f_5"
#include "bitmaps/f_6"
#include "bitmaps/f_7"
#include "bitmaps/f_8"
#include "bitmaps/f_9"
#include "bitmaps/f_10"
#include "bitmaps/f_11"
#include "bitmaps/f_12"

/*

*/
int    i_oud=10;
static Widget top;
static Widget label;
static Pixmap face0;  /* sleep  */
static Pixmap face1;  /* awake, smile */
static Pixmap face2;
static Pixmap face3; 
static Pixmap face4;
static Pixmap face5;
static Pixmap face6;
static Pixmap face7;
static Pixmap face8;
static Pixmap face9;
static Pixmap face10;  /* awake, crying */
static Pixmap face11;  /* asleep, crying */
static Pixmap face12;  /* down */
static void   update(); 
static XtIntervalId timer;

int main (argc, argv)
  int  argc;
  char **argv;
{
   Arg 		arg[5];
   int 		n;

   top = XtInitialize("belasting","Belasting",NULL,0,&argc,argv);

   face0 = XCreateBitmapFromData(XtDisplay(top),
                                 RootWindowOfScreen(XtScreen(top)),
                                 f_0_bits,
                                 f_0_width,
                                 f_0_height);
   face1 = XCreateBitmapFromData(XtDisplay(top),
                                 RootWindowOfScreen(XtScreen(top)),
                                 f_1_bits,
                                 f_1_width,
                                 f_1_height);
   face2 = XCreateBitmapFromData(XtDisplay(top),
                                 RootWindowOfScreen(XtScreen(top)),
                                 f_2_bits,
                                 f_2_width,
                                 f_2_height);
   face3 = XCreateBitmapFromData(XtDisplay(top),
                                 RootWindowOfScreen(XtScreen(top)),
                                 f_3_bits,
                                 f_3_width,
                                 f_3_height);
   face4 = XCreateBitmapFromData(XtDisplay(top),
                                 RootWindowOfScreen(XtScreen(top)),
                                 f_4_bits,
                                 f_4_width,
                                 f_4_height);
   face5 = XCreateBitmapFromData(XtDisplay(top),
                                 RootWindowOfScreen(XtScreen(top)),
                                 f_5_bits,
                                 f_5_width,
                                 f_5_height);
   face6 = XCreateBitmapFromData(XtDisplay(top),
                                 RootWindowOfScreen(XtScreen(top)),
                                 f_6_bits,
                                 f_6_width,
                                 f_6_height);
   face7 = XCreateBitmapFromData(XtDisplay(top),
                                 RootWindowOfScreen(XtScreen(top)),
                                 f_7_bits,
                                 f_7_width,
                                 f_7_height);
   face8 = XCreateBitmapFromData(XtDisplay(top),
                                 RootWindowOfScreen(XtScreen(top)),
                                 f_8_bits,
                                 f_8_width,
                                 f_8_height);
   face9 = XCreateBitmapFromData(XtDisplay(top),
                                 RootWindowOfScreen(XtScreen(top)),
                                 f_9_bits,
                                 f_9_width,
                                 f_9_height);
   face10 = XCreateBitmapFromData(XtDisplay(top),
                                 RootWindowOfScreen(XtScreen(top)),
                                 f_10_bits,
                                 f_10_width,
                                 f_10_height);
   face11 = XCreateBitmapFromData(XtDisplay(top),
                                 RootWindowOfScreen(XtScreen(top)),
                                 f_11_bits,
                                 f_11_width,
                                 f_11_height);
   face12 = XCreateBitmapFromData(XtDisplay(top),
                                 RootWindowOfScreen(XtScreen(top)),
                                 f_12_bits,
                                 f_12_width,
                                 f_12_height);

   


   n=0;
   XtSetArg(arg[n],XtNbitmap,face1); 			n++;
   XtSetArg(arg[n],XtNheight,100);                      n++;
   XtSetArg(arg[n],XtNwidth,100);                       n++;
         
   label = XtCreateManagedWidget("label",labelWidgetClass,top,arg,n); 
 
   XtRealizeWidget(top);
   timer = XtAddTimeOut(2500,update,0);
   XtMainLoop();  
}

static void update()
{
  Arg 	arg[5];
  int 	i=0,n=0;
  char  s1[10];
  float factor=2.3,load;
  FILE	*instruktie;
   struct pst_dynamic            dynamic_dummy;
   struct pst_dynamic            *dynamic;
   union  pstun                 pst;
   int				status;


      pst.pst_dynamic = (struct pst_dynamic *)malloc(sizeof(dynamic_dummy));
      if ((status = pstat(PSTAT_DYNAMIC, pst, sizeof(dynamic_dummy), 1, i)) == -1){
         perror("pstat");
         exit(1);
      }

   load = (float)pst.pst_dynamic->psd_avg_1_min;
   free(pst.pst_dynamic);
   i = (int) (floor((double) load*factor));
   if (i>12) i=12;
   if (i!=i_oud)
   {
      switch (i)
      {
         case 0: XtSetArg(arg[n],XtNbitmap,face0); break;
         case 1: XtSetArg(arg[n],XtNbitmap,face1); break;
         case 2: XtSetArg(arg[n],XtNbitmap,face2); break;
         case 3: XtSetArg(arg[n],XtNbitmap,face3); break;
         case 4: XtSetArg(arg[n],XtNbitmap,face4); break;
         case 5: XtSetArg(arg[n],XtNbitmap,face5); break;
         case 6: XtSetArg(arg[n],XtNbitmap,face6); break;
         case 7: XtSetArg(arg[n],XtNbitmap,face7); break;
         case 8: XtSetArg(arg[n],XtNbitmap,face8); break;
         case 9: XtSetArg(arg[n],XtNbitmap,face9); break;
         case 10: XtSetArg(arg[n],XtNbitmap,face10); break;
         case 11: XtSetArg(arg[n],XtNbitmap,face11); break;
         case 12: XtSetArg(arg[n],XtNbitmap,face12); break;
      }  
      n++;
      XtSetValues(label,arg,n);
   }
   i_oud = i;
   timer = XtAddTimeOut(2500,update,0);
} 
